﻿'''
    WarMod 1.5 (c) 2010 by Glazz
    - http://addons.eventscripts.com/addons/view/gwarmod

    =================================================================
    Credits:

        This addon is based on Master's Warmod v3.5.1
        I recoded most of the addon and added more features!

            View the original addon:
             - http://addons.eventscripts.com/addons/view/warmod

    =================================================================
    Thanks to everyone who helped me out in the EventScripts Forums, and special thanks to:
        - DanielB ( of course )
        - SuperDave
        - 101satoon101
        - Kana
        - freddukes
    
        I'm sorry if i miss anyone!!
'''


'''
==============================================================================
   IMPORTS
==============================================================================
'''
# Python Imports.
import cPickle, os, random, time, re

# Import EventScripts.
import es

# Import EventScripts Libraries.
import gamethread, langlib, playerlib, popuplib, usermsg
''' ; end ; '''


'''
==============================================================================
   ADDON INFO
==============================================================================
'''
addon = {
    'name'       : 'WarMod',
    'version'    : '1.5',
    'date'       : '06.08.2010',
    'updated'    : '17.08.2010',
    'author'     : 'G l a z z',
    'description': 'An addon to help you manage your war server.',
    'url'        : 'http://addons.eventscripts.com/addons/view/gwarmod',
    'basename'   : 'gwarmod'
}

info = es.AddonInfo()
for i in addon:
    info[i] = addon[i]

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()
''' ; end ; '''


'''
==============================================================================
   CONFIG VARIABLES
==============================================================================
'''
gw_hostname             = es.ServerVar('gw_hostname')
gw_hostname_war         = es.ServerVar('gw_hostname_war')
gw_language             = es.ServerVar('gw_language')
gw_sourcetv_addr        = es.ServerVar('gw_sourcetv_addr')
gw_chat_prefix          = es.ServerVar('gw_chat_prefix')
gw_chat                 = es.ServerVar('gw_chat')
gw_chat_dead            = es.ServerVar('gw_chat_dead')
gw_opoints              = es.ServerVar('gw_opoints')
gw_ragdolls             = es.ServerVar('gw_ragdolls')
gw_ready_sys            = es.ServerVar('gw_ready_sys')
gw_round_max            = es.ServerVar('gw_round_max')
gw_round_win            = es.ServerVar('gw_round_win')
gw_read_maps            = es.ServerVar('gw_read_maps')
gw_ratecheck            = es.ServerVar('gw_ratecheck')
gw_rate                 = es.ServerVar('gw_rate')
gw_cmdrate              = es.ServerVar('gw_cmdrate')
gw_updrate              = es.ServerVar('gw_updrate')
gw_pf_active            = es.ServerVar('gw_pf_active')
gw_pf_fps_max_idle      = es.ServerVar('gw_pf_fps_max_idle')
gw_pf_fps_max_nonidle   = es.ServerVar('gw_pf_fps_max_nonidle')
gw_sourcetv_idle        = es.ServerVar('gw_sourcetv_idle')
gw_sourcetv_nonidle     = es.ServerVar('gw_sourcetv_nonidle')
gw_sourcetv_autorec_lo3 = es.ServerVar('gw_sourcetv_autorec_lo3')
gw_sourcetv_autorec_ko3 = es.ServerVar('gw_sourcetv_autorec_ko3')
gw_result_save          = es.ServerVar('gw_result_save')
''' ; end ; '''


'''
==============================================================================
   PATH
==============================================================================
'''
warPath = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
''' ; end ; '''

'''
==============================================================================
    REGULAR EXPRESSION, this is needed to read the 'Configs' file.
==============================================================================
'''
# We have to compile each RE expression
# It can take a second, so it's best to do it only once
RE_QUOTES = re.compile(r'\".*?\"')
''' ; end ; '''


'''
==============================================================================
   DICTs
==============================================================================
'''
Admins      = []
Bans        = {}
Configs     = {}
Language    = None
Maps        = []
myPopups    = {}
Passwords   = []
Players     = {}
Results     = {}
Store       = {
    'active'  : 0, # If the war is active.
    'rsystem' : 0, # Ready System is activated? If so, the players need to type .r in the chat.
    'swaps'   : 0, # This controls the number of swaps the teams have made.
    'oswaps'  : 0, # Number of times a team have been swapped in Overtime.
    'rounds'  : 0, # Number of the rounds played.
    'mode'    : 0, # Game mode: 0 = None | 1 = Knife mode | 2 - Overtime mode
    'team1'   : { 'name' : 'Team 1', 'score' : 0 },
    'team2'   : { 'name' : 'Team 2', 'score' : 0 },
    'demo'    : ''
}
''' ; end ; '''


'''
==============================================================================
   EVENTS
==============================================================================
'''

'''
| Event:  load()
|
|   ->  When the addon is loaded.
|
'''
def load():
    # Global variables.
    global Admins, Bans, Configs, Language, Maps, Passwords, Players, Language, Results

    # Load: Config File #
    es.server.cmd('es_xmexec ../cfg/%s/config.cfg' % info['basename'])

    # Load: Admins , Bans , Language , Maps , Passwords , Results
    Admins    = LoadAdmins()
    Bans      = FileLoad(es.getAddonPath(info['basename']) + '/bans.db')
    Configs   = LoadConfigs()
    Language  = langlib.Strings('%s/cfg/%s/language.ini' % (warPath, info['basename']))
    Maps      = LoadMaps()
    Passwords = LoadPasswords()
    Results   = FileLoad(es.getAddonPath(info['basename']) + '/results.db')

    # Register the chat filter.
    es.addons.registerSayFilter(ChatFilter)

    # Register client commands.
    es.regclientcmd('wm_admin',  '%s/WarAdmin' % info['basename'],    'Opens the Admin menu.')
    es.regclientcmd('wm_lo3',    '%s/WarStart' % info['basename'],    'Starts a War')
    es.regclientcmd('wm_ko3',    '%s/WarStartKO3' % info['basename'], 'Starts a Knife Fight')
    es.regclientcmd('wm_force',  '%s/WarForce' % info['basename'],    'Forces a War to Start')
    es.regclientcmd('wm_cancel', '%s/WarCancel' % info['basename'],   'Cancels a War')

    # Set all players as not ready.
    for i in playerlib.getUseridList('#all,#human'):
        if not Players.has_key(int(i)):
            Players[int(i)] = 0

    # Notify cvars
    for i in ['gw_round_max', 'gw_round_win']:
        es.flags('add', 'notify', i)

    # Performance check.
    #PerformanceCheck()

    # Addon was Loaded, send message
    tokens = {}
    tokens['script'] = info['name']
    tokens['version'] = info['version']
    msg(Language('addon loaded', tokens, str(gw_language)))
''' ; end - load() ; '''

'''
| Event:  unload()
|
|   ->  When the addon is unloaded.
|
'''
def unload():
    # Unregister the chat filter
    es.addons.unregisterSayFilter(ChatFilter)

    # Unregister client commands.
    for c in [ 'wm_admin', 'wm_lo3', 'wm_ko3', 'wm_force', 'wm_cancel' ]:
        es.unregclientcmd('%s' % c) 

    # If a war is active, try to stop the demo record.
    if int(Store['active']) == 1:
        SourceTv_StopRec()

    # Addon was UnLoaded, send message
    tokens = {}
    tokens['script'] = info['name']
    tokens['version'] = info['version']
    msg(Language('addon unloaded', tokens, str(gw_language)))
''' ; end - unload() ; '''

'''
| Event:  player_spawn()
|
|   ->  When a player spawns.
|
'''
def player_spawn(ev):
    # UserID.
    UserID = int(ev['userid'])

    # Check player rates?
    if int(gw_ratecheck) == 1:
        rateChecker(UserID)

    # Is the knife round active?
    if int(Store['active']) == 1 and int(Store['mode']) == 1:
        Knife(UserID, True)
''' ; end - player_spawn() ; '''

'''
| Event:  player_death()
|
|   ->  When a player dies.
|
'''
def player_death(ev):
    # Should we remove the body?
    if int(gw_ragdolls) == 1:
        es.delayed(0.1, 'es_fire %i cs_ragdoll kill' % int(ev['userid']))
''' ; end - player_death() ; '''

'''
| Event:  player_activate()
|
|   ->  When a player joins the server.
|
'''
def player_activate(ev):
    # UserID.
    UserID = int(ev['userid'])

    # If the player is not a BOT set him/her as not ready.
    if not es.getplayersteamid(UserID) == 'BOT':
        Players[UserID] = 0

    # If Ready System is active, send the menu to all the players.
    if int(Store['rsystem']) == 1:
        readySystem()

    # Performance check.
    #PerformanceCheck()
''' ; end - player_activate() ; '''

'''
| Event:  player_disconnect()
|
|   ->  When a player leaves the server.
|
'''
def player_disconnect(ev):
    # UserID
    UserID = int(ev['userid'])

    # Delete the player from the list.
    if Players.has_key(UserID):
        del Players[UserID]

    # If Ready System is active, send the menu to all the players.
    if int(Store['rsystem']) == 1:
        readySystem()

    # Performance check.
    #PerformanceCheck()
''' ; end - player_disconnect() ; '''

'''
| Event:  round_start()
|
|   ->  When a round starts.
|
'''
def round_start(ev):
    # If the war is active.
    if int(Store['active']) == 1:
        # Not in knife mode.
        if int(Store['mode']) == 0 or int(Store['mode']) == 2:
            # Tell the money of all Terrorists.
            pl = playerlib.getUseridList('#t,#human')
            for userid in pl:
                name  = es.getplayername(userid)
                money = es.getplayerprop(userid, 'CCSPlayer.m_iAccount')
                tell(userid, Language('team money', {}, str(gw_language)))
                for u in pl:
                    gamethread.delayed(0.1, SayMoney, (u, name, money))

            # Tell the money of all Counter-Terrorists.
            pl = playerlib.getUseridList('#ct,#human')
            for userid in pl:
                name  = es.getplayername(userid)
                money = es.getplayerprop(userid, 'CCSPlayer.m_iAccount')
                tell(userid, Language('team money', {}, str(gw_language)))
                for u in pl:
                    gamethread.delayed(0.1, SayMoney, (u, name, money))
''' ; end - round_start() ; '''

'''
| Event:  round_end()
|
|   ->  When a round ends.
|
'''
def round_end(ev):
    # 0 - Normal Round.
    if int(Store['active']) == 1 and int(Store['mode']) == 0:
        # If the round has ended properly.
        if ev['reason'] not in ['10', '16']:
            # Terrorists Won the round.
            if ev['winner'] == '2':
                # If teams have swapped.
                if Store['rounds'] < int(gw_round_max):
                    Store['team1']['score'] += 1
                else:
                    Store['team2']['score'] += 1

            # Counter-Terrorists Won the round.
            if ev['winner'] == '3':
                # If teams have swapped.
                if Store['rounds'] < int(gw_round_max):
                    Store['team2']['score'] += 1
                else:
                    Store['team1']['score'] += 1

            # Sum 1 more round.
            Store['rounds'] += 1

        # Say the actual score.
        SayScore()

        # We arrived the max number of rounds, let's swap teams.
        if Store['rounds'] == int(gw_round_max):
            # War is not active.
            Store['active'] = 0

            # Send message.
            msg(Language('war interval', {}, str(gw_language)))

            # Swap teams, reset all players and start ready system.
            gamethread.delayed(1.5, SwapTeams)
            gamethread.delayed(1.5, ResetPlayers)
            gamethread.delayed(2, readySystem)

        # T team Won.
        elif Store['team1']['score'] == int(gw_round_win):
            # Send message.
            tokens = {}
            tokens['team'] = Store['team1']['name']
            msg(Language('war end', tokens, str(gw_language)))

            # Stop recording.
            SourceTv_StopRec()

            # Reset Data.
            DataReset()

            # Change hostname and restart round.
            gamethread.delayed(1, es.server.queuecmd, 'hostname %s' % gw_hostname)
            gamethread.delayed(1, es.server.queuecmd, 'mp_restartgame 1')

        # CT team Won.
        elif Store['team2']['score'] == int(gw_round_win):
            # Send message. 
            tokens = {}
            tokens['team'] = Store['team2']['name']
            msg(Language('war end', tokens, str(gw_language)))

            # Stop recording.
            SourceTv_StopRec()

            # Reset Data.
            DataReset()

            # Change hostname and restart round.
            gamethread.delayed(1, es.server.queuecmd, 'hostname %s' % gw_hostname)
            gamethread.delayed(1, es.server.queuecmd, 'mp_restartgame 1')

        # Teams are Tied.
        elif Store['team1']['score'] == Store['team2']['score'] == (gw_round_win-1):
            # Send message.
            tokens = {}
            tokens['rounds'] = gw_round_win-1
            msg(Language('war tied', tokens, str(gw_language)))

            # Reset data, reset all players and start ready system.
            gamethread.delayed(1.5, DataReset, (2))
            gamethread.delayed(1.5, ResetPlayers)
            gamethread.delayed(2, readySystem)

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    # 1 - Knife Round.
    if int(Store['active']) == 1 and int(Store['mode']) == 1:
        uid = int(es.getcmduserid())
        Knife(uid, False)
        Store['active'] = 0
        Store['mode'] = 0

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    # 2 - Overtime.
    if int(Store['active']) == 1 and int(Store['mode']) == 2:
        # If the round has ended properly.
        if ev['reason'] not in ['10', '16']:
            # Terrorists Won the round.
            if ev['winner'] == '2':
                # If teams have swapped.
                if Store['rounds'] < 3:
                    Store['team1']['score'] += 1
                else:
                    Store['team2']['score'] += 1

            # Counter-Terrorists Won the round.
            if ev['winner'] == '3':
                # If teams have swapped.
                if Store['rounds'] < 3:
                    Store['team2']['score'] += 1
                else:
                    Store['team1']['score'] += 1

        # Sum 1 more round.
        Store['rounds'] += 1

        # Say the actual score.
        SayScore()

        # We arrived the max number of rounds, let's swap teams. #
        if Store['rounds'] == 3:
            # War is not active.
            Store['active'] = 0

            # Send message. #
            msg(Language('war interval', {}, str(gw_language)))
 
            # Swap teams, reset all players and start ready system.
            gamethread.delayed(1, SwapTeams)
            gamethread.delayed(1.3, ResetPlayers)
            gamethread.delayed(2, readySystem)

        # T team Won.
        elif Store['team1']['score'] == 4:
            # Send message.
            tokens = {}
            tokens['team'] = Store['team1']['name']
            msg(Language('war end', tokens, str(gw_language)))

            # Stop recording.
            SourceTv_StopRec()

            # Reset Data.
            DataReset()

            # Change hostname and restart round.
            gamethread.delayed(1, es.server.queuecmd, 'hostname %s' % gw_hostname)
            gamethread.delayed(1, es.server.queuecmd, 'mp_restartgame 1')

        # CT team Won.
        elif Store['team2']['score'] == 4:
            # Send message.
            tokens = {}
            tokens['team'] = Store['team2']['name']
            msg(Language('war end', tokens, str(gw_language)))

            # Stop recording.
            SourceTv_StopRec()

            # Reset Data.
            DataReset()

            # Change hostname and restart round.
            gamethread.delayed(1, es.server.queuecmd, 'hostname %s' % gw_hostname)
            gamethread.delayed(1, es.server.queuecmd, 'mp_restartgame 1')
 
        # Teams are Tied.
        elif Store['team1']['score'] == Store['team2']['score'] == 3:
            # War is not active.
            Store['active'] = 0

            # Send message.
            msg(Language('war interval', {}, str(gw_language)))

            # Swap teams, reset data, reset all players and start ready system.
            gamethread.delayed(1, SwapTeams)
            gamethread.delayed(1.3, DataReset, (2))
            gamethread.delayed(1.6, ResetPlayers)
            gamethread.delayed(2, readySystem)
''' ; end - round_end() ; '''

'''
| Event:  bomb_defused()
|
|   ->  If the bomb gets defused, should we give points to the defuser for the defuse?
|
'''
def bomb_defused(ev):
    # Check if we want the defuser to recieve his points.
    if not int(gw_opoints):
        es.server.queuecmd('score del %i 1' % int(ev['userid']))
''' ; end - bomb_defused() ; '''

'''
| Event:  bomb_exploded()
|
|   ->  If the bomb gets exploded, should we give points to the bomber for the exploded bomb?
|
'''
def bomb_exploded(ev):
    # Check if we want the bomber to receive his points.
    if not int(gw_opoints):
        es.server.queuecmd('score del %i 3' % int(ev['userid']))
''' ; end - bomb_exploded() ; '''


'''
==============================================================================
   FUNCTIONS
==============================================================================
'''


def regexSplit(text):
   match = RE_QUOTES.search(text) # We find the matching text
   # We split the string into two parts at the end of the matching text
   return text[1:match.end() - 1], text[match.end() + 1:]

'''
| Funct:  PerformanceCheck()
|
|   ->  This function is usefull to improve server performance when the server is idle.
|       º This changes the 'fps_max' cvar when the server is Idle or Non Idle.
|       º This Removes SourceTv if the server is idle.
|
'''
def PerformanceCheck():
    # Count total of players on the server.
    players = len(es.getUseridList())
    playerlist = es.createplayerlist()
    tv = 1 if filter(lambda userid: int(playerlist[userid]['ishltv']), playerlist) else 0

    # Can we set fps_max?
    if int(gw_pf_active) == 1:
        # Server is not Idle, try to change fps_max...
        if players >= 1 and es.getInt('fps_max') != gw_pf_fps_max_nonidle:
            es.server.insertcmd('fps_max ' + str(gw_pf_fps_max_nonidle))

        # Server seems to be Idle, try to change fps_max...
        elif es.getInt('fps_max') != gw_pf_fps_max_idle:
            es.server.insertcmd('fps_max ' + str(gw_pf_fps_max_idle))

    '''
    # Remove SourceTv?
    if int(gw_sourcetv_idle) == 1 and players == 1:
        # Check SourceTv status.
        playerlist = es.createplayerlist()
        tv = filter(lambda userid: int(playerlist[userid]['ishltv']), playerlist)
    
        # SourceTv is on?
        if tv:
            # Remove the SourceTv.
            es.server.queuecmd('tv_enable 0')
            es.server.queuecmd('tv_stop')

    # Bring Back the SourceTv?
    if int(gw_sourcetv_nonidle) == 1 and players == 1 and tv == 0:
        # Turn the Tv On.
        es.server.queuecmd('tv_enable 1')
    
        # Restart map.
        gamethread.delayed(6, es.server.queuecmd, 'changelevel %s' % es.ServerVar('eventscripts_currentmap'))
    
        # Send message.
        for i in range(0, 3):
            gamethread.delayed(3, msg, Language('warning sourcetv on', {}, str(gw_language)))
    '''
''' ; end - PerformanceCheck() ; '''

'''
| Func:  Colorize()
|
|   ->  This function is used to replace color tokens in a text.
|
|   @params - text      string
|
'''
def Colorize(text):
    # Do the replacements.
    text = text.replace('#dg', '\x05').replace('#d', '#default').replace('#g', '#green').replace('#l', '#lightgreen')

    # Return text.
    return text
''' ; end - Colorize() ; '''

'''
| Func:  hud()
|
|   ->  This function sends messages to the HUD system, if a userid is specified
|       the function sends the message to that user, if not, sends to all the users.
|
|   @params - text      string
|   @params - userid    integer
|
'''
def hud(text, userid = False):
    if not userid:
        usermsg.hudhint(playerlib.getUseridList('#human'), text)
    else:
        usermsg.hudhint(userid, text)
''' ; end - hud() ; '''

'''
| Func:  msg()
|
|   ->  This function sends messages to everyone on the server, 
|       and shows them in the game chat area.
|
|   @params - text      string
|
'''
def msg(text):
    es.msg('#multi', Colorize(text))
''' ; end - msg() ; '''

'''
| Func:  msgAdmin()
|
|   ->  This function sends messages to ADMINS only!
|
|   @params - text      string
|
'''
def msgAdmin(text):
    pl = playerlib.getPlayerList('#all,#human')
    for uid in pl:
        sid = es.getplayersteamid(uid)
        if sid in Admins:
            tell(uid, text)
''' ; end - msgAdmin() ; '''

'''
| Func:  centermsg()
|
|   ->  This function sends messages to everyone on the server, 
|       and shows them in the middle of the screen.
|
|   @params - text      string
|
'''
def centermsg(text):
    es.centermsg(text)
''' ; end - centermsg() ; '''

'''
| Func:  tell()
|
|   ->  This is used to send messages to a specific user.
|
|   @params - userid    integer
|   @params - text      string
|
'''
def tell(userid, text):
    es.tell(userid, '#multi', Colorize(text))
''' ; end - tell() ; '''

'''
| Func: KeyHintText()
|
|   ->  Send a message in to the right of the screen.
|
'''
def KeyHintText(userid, text):
    es.usermsg('create', 'mymsg', 'KeyHintText')
    es.usermsg('write', 'byte', 'mymsg', 1)
    es.usermsg('write', 'string', 'mymsg', text)
    es.usermsg('send', 'mymsg', userid)
    es.usermsg('delete', 'mymsg')
''' ; end - KeyHintText() ; '''

'''
| Func:  LoadAdmins()
|
|   ->  This function gets all the admins from the file to a dict.
|
'''
def LoadAdmins():
    # Create a blank dict.
    list = []

    # Handle file.
    file = open('%s/cfg/%s/admins.txt' % (warPath, info['basename']), 'rb')
    lines = file.readlines()
    file.close()

    # List the admins in the file.
    for line in lines:
        comment = line.find('//')
        if comment > -1: line = line[:comment]
        comment = line.find('#')
        if comment > -1: line = line[:comment]
        line = line.strip()
        if line: list.append(line)
    return list
''' ; end - LoadAdmins() ; '''

'''
| Func: LoadConfigs()
|
|   ->  This function gets all the configs you want to execute from a file.
|
'''
def LoadConfigs():
    # Create a blank dict.
    list = {}

    # Handle file.
    file = open('%s/cfg/%s/configs.txt' % (warPath, info['basename']), 'rb')
    lines = file.readlines()
    file.close()

    # List the passwords in the file.
    for line in lines:
        comment = line.find('/')
        if comment > -1: line = line[:comment]
        comment = line.find('#')
        if comment > -1: line = line[:comment]
        line = line.strip()
        if line:
            line = regexSplit(line)
            # Check if config file exists.
            if os.path.isfile('%s/cfg/%s/configs/%s' % (warPath, info['basename'], line[1])):
                list[line[0]] = line[1]
    return list
''' ; end - LoadConfigs() ; '''

'''
| Func:  LoadPasswords()
|
|   ->  This function gets all the passwords from the file to a dict.
|
'''
def LoadPasswords():
    # Create a blank dict.
    list = []

    # Handle file.
    file = open('%s/cfg/%s/passwords.txt' % (warPath, info['basename']), 'rb')
    lines = file.readlines()
    file.close()

    # List the passwords in the file.
    for line in lines:
        comment = line.find('/')
        if comment > -1: line = line[:comment]
        comment = line.find('#')
        if comment > -1: line = line[:comment]
        line = line.strip()
        if line: list.append(line)
    return list
''' ; end - LoadPasswords() ; '''

'''
| Func:  LoadMaps()
|
|   ->  This function lists all the maps from the maps dir or from a file.
|
'''
def LoadMaps():
    # Create a blank dict.
    list = []

    # Check the way to load maps.
    if gw_read_maps >= 1:
        mapList = 'maplist.txt' if gw_read_maps == 1 else 'cfg/%s/maplist.txt' % info['basename']

        # Handle file. #
        file = open('%s/%s' % (warPath, mapList), 'rb')
        lines = file.readlines()
        file.close()

        # List the maps in the file.
        for line in lines:
            comment = line.find('//')
            if comment > -1: line = line[:comment]
            comment = line.find('#')
            if comment > -1: line = line[:comment]
            line = line.strip()
            if line: list.append(line)
        return list
    else:
        # List maps on the folder.
        for x in os.listdir('%s/maps' % warPath):
            if '.bsp' in x:
                if '.ztmp' not in x:
                    if '.bz2' not in x:
                        map = x.replace('.bsp', '')
                        list.append(map)

    # Return maps.
    return list
''' ; end - LoadMaps() ; '''

'''
| Func:  CheckTeam()
|
|   ->  This function is used to check 3 things:
|       . Check if a player is on a team, T or CT;
|           - This returns a boolean.
|       . Check in wich team the player is on, and return the opposite team number;
|           - This returns an integer.
|       . Check in wich team the player is on, and return the name of that team.
|           - This returns a string.
|
|   @params - userid    integer
|   @params - type      integer
|
'''
def CheckTeam(userid, type = 0):
    # Get player team.
    team = int(es.getplayerteam(userid))

    # See what we want to check.
    if type == 1:
        # If the player is on T or CT side.
        if team in ['2', '3']:
            return True
        return False

    elif type == 2:
        # If the player is on T side, return CT side team number
        if team == 2:
            return 3
        # If the player is on CT side, return T side team number
        elif team == 3:
            return 2
        # If the player is not on T or CT, means that he is Spectating.
        else:
            return 1

    elif type == 3:
        if team == 2:
            return '[T]'
        elif team == 3:
            return '[CT]'
        elif team == 1:
            return '[SPEC]'
''' ; end - CheckTeam() ; '''

'''
| Func:  TagChecker()
|
|   ->  This function detects the Clan Tag of a desired team,
|       if the tag itself exists of course.
|
|   @params - team    string
|
'''
def TagChecker(team):
    # Get player list from the desired team.
    #pl = playerlib.getPlayerList('#%s,#human' % team)
    pl = playerlib.getPlayerList('#%s' % team)
    names = ' '.join(i.name for i in pl)

    # Cycle through names.
    result = {}
    for e in names.split():
        result[e] = result.get(e, 0) + 1

    # Return the team tag.
    if len(result) >= 2:
        return max(result, key = lambda  x: result[x])
    else:
        return 'Team-%s' % team
''' ; end - TagChecker() ; '''

'''
| Func:  ChangeConfig()
|
|   ->  This function changes the server's config.
|
|   @params - params    array
|
'''
def ChangeConfig(userid, choice, popup):
    # Variables.
    aid    = int(userid)
    choice = choice

    # Change config.
    es.server.cmd('es_xmexec ../cfg/%s/configs/%s' % (info['basename'], choice))

    # Save the log.
    LogSave(aid, 'Changed Config:', choice)

    # Send the menu.
    myPopups['wm_men3'].send(userid)
''' ; end - ChangeConfig() ; '''

'''
| Func:  ChangePassword()
|
|   ->  This function changes the server's password.
|
|   @params - params    array
|
'''
def ChangePassword(userid, choice, popup):
    # Variables.
    aid    = int(userid)
    choice = choice

    # Change password.
    es.server.queuecmd('sv_password %s' % choice)

    # Send message.
    if choice == 'none':
        msg(Language('password none', {}, str(gw_language)))
    else:
        msg(Language('password changed', {'password':choice}, str(gw_language)))

    # Save the log.
    LogSave(aid, 'Changed Password:', choice)

    # Send the menu.
    myPopups['wm_men4'].send(userid)
''' ; end - ChangePassword() ; '''

'''
| Func:  ChangeMap()
|
|   ->  This function changes map.
|
|   @params - params    array
|
'''
def ChangeMap(userid, choice, popup):
    # Variables.
    aid    = int(userid)
    choice = choice

    # If a war is active, try to stop the demo record.
    if int(Store['active']) == 1:
        SourceTv_StopRec()

    # Save the log.
    LogSave(aid, 'Changed Map:', choice)

    # Change map.
    es.server.queuecmd('changelevel %s' % choice)
''' ; end - ChangeMap() ; '''

'''
| Func:  Kick()
|
|   ->  This function kick's a player.
|
|   @params - params    array
|
'''
def Kick(userid, choice, popup = False):
    # Variables.
    aid = int(userid)
    kid = int(choice)
    aUsername = es.getplayername(aid)
    kUsername = es.getplayername(kid)

    # Kick the player.
    es.server.queuecmd('kickid %s' % kid)

    # Send message.
    tokens = {}
    tokens['admin'] = aUsername
    tokens['player'] = kUsername
    msg(Language('kick', tokens, str(gw_language)))

    # Save the log.
    LogSave(aid, 'kick', kid)

    # Send the popup again.
    WarMenus(aid, 'wm_men7.1.1')
''' ; end - Kick() ; '''

'''
| Func:  KickTeam()
|
|   ->  This function kick's all player in a team.
|
|   @params - team      string
|   @params - aid       integer
|
'''
def KickTeam(team, aid):
    pl = playerlib.getUseridList('#%s,#human' % team)
    for uid in pl:
        Kick(aid, uid)
''' ; end - KickTeam() ; '''

'''
| Func:  Ban()
|
|   ->  This function ban's a player.
|
|   @params - params    array
|
'''
def Ban(userid, choice, popup = False):
    # Variables.
    aid = int(userid)
    bid = int(choice)
    aUsername = es.getplayername(aid)
    bUsername = es.getplayername(bid)
    bSteamID  = es.getplayersteamid(bid)

    # Ban the player.
    es.server.queuecmd('banid 0 %s kick' % bid)
    es.server.queuecmd('writeid')

    # Send message.
    tokens = {}
    tokens['admin'] = aUsername
    tokens['player'] = bUsername
    msg(Language('ban', tokens, str(gw_language)))

    # Save the ban in the database.
    Bans[bSteamID] = { 'by' : aUsername, 'date' : time.strftime('%d.%m.%Y %H:%M', time.localtime()) }
    FileSave(es.getAddonPath(info['basename']) + '/bans.db', Bans)

    # Save the log.
    LogSave(aid, 'ban', bid)

    # Send the popup again.
    WarMenus(aid, 'wm_men7.2.1')
''' ; end - Ban() ; '''

'''
| Func:  BanTeam()
|
|   ->  This function ban's all player in a team.
|
|   @params - team      string
|   @params - aid       integer
|
'''
def BanTeam(team, aid):
    pl = playerlib.getUseridList('#%s,#human' % team)
    for uid in pl:
        Ban(aid, uid)
''' ; end - BanTeam() ; '''

'''
| Func:  Unban()
|
|   ->  This function removes ban from a player.
|
|   @params - params    array
|
'''
def Unban(userid, choice, popup):
    # Variables.
    aid = int(userid)
    uid = int(choice)
    aUsername = es.getplayername(aid)
    uUsername = es.getplayername(uid)
    uSteamID  = es.getplayersteamid(uid)

    # Unban the player.
    es.server.queuecmd('removeid %s' % uid)
    es.server.queuecmd('writeid')

    # Send message.
    tokens = {}
    tokens['admin'] = aUsername
    tokens['player'] = uUsername
    msg(Language('unban', tokens, str(gw_language)))

    # Save the Database.
    del Bans[uSteamID]
    FileSave(es.getAddonPath(info['basename']) + '/bans.db', Bans)

    # Save the log.
    LogSave(aid, 'Unbanned:', uid)

    # Send the popup again.
    gamethread.delayed(0.1, myPopups['wm_men7_3'].send, (aid))
    #gamethread.delayed(0.1, WarMenus, (aid, 'men7_3', True))
''' ; end - Unban() ; '''

'''
| Func:  SwapTeam()
|
|   ->  This function swaps a player to the opposite team.
|
|   @params - params    array
|
'''
def SwapTeam(userid, choice, popup):
    # Variables.
    aid = int(userid)
    sid = int(choice)
    aUsername = es.getplayername(aid)
    sUsername = es.getplayername(sid)

    # Swap player to other team.
    TeamSwapper(sid, CheckTeam(sid, 2))

    # Send message.
    tokens = {}
    tokens['admin'] = aUsername
    tokens['player'] = sUsername
    msg(Language('swap', tokens, str(gw_language)))

    # Send the popup again.
    WarMenus(aid, 'wm_men7.4')
''' ; end - SwapTeam() ; '''

'''
| Func:  SwapSpec()
|
|   ->  This function swaps a player to spectator.
|
|   @params - params    array
|
'''
def SwapSpec(userid, choice, popup):
    # Variables.
    aid = int(userid)
    sid = int(choice)
    aUsername = es.getplayername(aid)
    sUsername = es.getplayername(sid)

    # Swap player to spectator.
    TeamSwapper(sid, 1)

    # Send message.
    tokens = {}
    tokens['admin'] = aUsername
    tokens['player'] = sUsername
    msg(Language('swap spec', tokens, str(gw_language)))

    # Send the popup again.
    #gamethread.delayed(0.1, myPopups['men7_6_1'].send, (aid))
    #gamethread.delayed(0.1, WarMenus, (aid, 'men7_6_1', True))
    WarMenus(aid, 'wm_men7.6.1')
''' ; end - SwapSpec() ; '''

'''
| Funct:  SwapTeams()
|
|   ->  This function swaps the players.
|
'''
def SwapTeams():
    # Get player list from both team.
    t = playerlib.getUseridList('#t,#human')
    ct = playerlib.getUseridList('#ct,#human')

    # Swap Counter-Terroristas.
    for userid in t:
        TeamSwapper(userid, 3)

    # Swap Terrorists.
    for userid in ct:
        TeamSwapper(userid, 2)
''' ; end - SwapTeams() ; '''

'''
| Func:  TeamSwapper()
|
|   ->  This function swaps a player from his team..
|
|   @params - uid       integer
|   @params - tid       integer
|
'''
def TeamSwapper(uid, tid):
    # Swap player.
    es.server.queuecmd('es_xchangeteam %i %i' % (uid, tid))

    # Save the log.
    #LogSave(aid, 'Swapped to %s team:' % team, bid)
''' ; end - TeamSwapper() ; '''

'''
| Func:  FileSave()
|
|   ->  This function saves data into a file.
|
|   @params - file      string
|   @params - data      string
|
'''
def FileSave(file, data):
    iFile = open(file, 'w')
    cPickle.dump(data, iFile)
    iFile.close()
''' ; end - FileSave() ; '''

'''
| Func:  FileLoad()
|
|   ->  This function loads data from a file.
|
|   @params - file      string
|
'''
def FileLoad(file):
    if os.path.isfile(file):
        oFile = open(file)
        data = cPickle.load(oFile)
        oFile.close()
        return data
    else:
        return {}
''' ; end - FileLoad() ; '''

'''
| Func:  LogSave()
|
|   ->  This function saves logs in a file.
|
|   @params - aid       integer
|   @params - waht      string
|   @params - var       string | integer
|
'''
def LogSave(aid, what, var = None):
    # Variables.
    aUsername = es.getplayername(aid)
    aSteamID  = es.getplayersteamid(aid)
    date = time.strftime('%d/%m/%Y %H:%M:%S', time.localtime())
    logfile = '%s/cfg/%s/logs/%s.txt' % (warPath, info['basename'], aSteamID.replace(':', ''))

    # What do we want to Log?
    if what in [ 'kick', 'ban' ]:
        uUsername = es.getplayername(var)
        uSteamID  = es.getplayersteamid(var)

        typee = 'Kicked' if what == 'kick' else 'Banned'
        message = '%s : %s - <%s> -> %s: <%s> <%s>' % (date, aSteamID, aUsername, typee, uSteamID, uUsername)

    elif what == 'cvar':
        message = 'test'

        # isto e para quando mudamos o alltalk, ready system etc...
    else:
        if var != None:
            message = '%s : %s - <%s> -> %s: <%s>' % (date, aSteamID, aUsername, what, var)
        else:
            message = '%s : %s - <%s> -> %s' % (date, aSteamID, aUsername, what)

    iFile = open(logfile, 'a')
    iFile.write(message + '\n')
    iFile.close()
''' ; end ; '''





def ResultSave():
    # Variables.
    date = time.strftime('%d-%m-%Y %H-%M-%S', time.localtime())
    resultfile = '%s/cfg/%s/logs/%s.txt' % (warPath, info['basename'], date)

    # Save the result.
    iFile = open(resultfile, 'a')
    iFile.write(message + '\n')
    iFile.close()
''' ; end ; '''





'''
| Function: rateCheckerGlobal()
|
|   This functions checks everyone rates and let the admin know about low raters.
|
'''
def rateCheckerGlobal():
    for uid in playerlib.getUseridList('#all,#human'):
        rateChecker(uid)
''' ; end ; '''

'''
| Funcao: rateChecker()
|
|    Esta funcao verifica as rates de cada utilizador, quem tiver as rates mal e informado em cada ronda!
|
'''
def rateChecker(uid):
    # Variables.
    UserID   = int(uid)
    Username = es.getplayername(UserID)

    # If the player is a BOT we stop here.
    if es.getplayersteamid(UserID) == 'BOT':
        return

    # Client CVARs.
    clt_rate    = es.getclientvar(UserID, 'rate')
    clt_cmdrate = es.getclientvar(UserID, 'cl_cmdrate')
    clt_updrate = es.getclientvar(UserID, 'cl_updaterate')

    # Control vars.
    rate    = 0
    cmdrate = 0
    updrate = 0

    # Check: rate
    if gw_rate <> clt_rate: rate = 1

    # Check: cl_cmdrate
    if gw_cmdrate <> clt_cmdrate: cmdrate = 1

    # Check: cl_updaterate
    if gw_updrate <> clt_updrate: updrate = 1

    # If we have incorrect rates.
    if rate == 1 or cmdrate == 1 or updrate == 1:
        # Send message to low rater.
        txt_rate    = '#g' if rate    else '#l'
        txt_cmdrate = '#g' if cmdrate else '#l'
        txt_updrate = '#g' if updrate else '#l'

        tokens = {}
        tokens['t_rate']    = txt_rate
        tokens['v_rate']    = gw_rate
        tokens['t_cmdrate'] = txt_cmdrate
        tokens['v_cmdrate'] = gw_cmdrate
        tokens['t_updrate'] = txt_updrate
        tokens['v_updrate'] = gw_updrate
        tell(UserID, Language('rate warn player', tokens, str(gw_language)))

        # Warn admins online.
        msgAdmin(Language('rate warn admin', {'player':Username}, str(gw_language)))
''' ; end ; '''

'''
| Func:  SayMoney()
|
|   ->  This function tells the money that a player haves.
|
|   @params - uid       integer
|   @params - name      string
|   @params - money     boolean / string
|
'''
def SayMoney(uid, name, money):
    # Prepare the message.
    tokens = {}
    tokens['name'] = name
    tokens['money'] = money
    text = Language('say money', tokens, str(gw_language))
    text = text.replace('#dg', '\x05').replace('#d', '\x01').replace('#g', '\x04').replace('#l', '\x03')

    # Send the message.
    player = playerlib.getPlayer(uid)
    index = player.attributes['index']
    usermsg.saytext2(uid, index, text)
''' ; end - SayMoney() ; '''

'''
| Func:  SourceTv_Manager()
|
|   ->  This functions turns On / Off the SourceTv.
|
'''
def SourceTv_Manager():
    # Check SourceTv status.
    playerlist = es.createplayerlist()
    tv = filter(lambda userid: int(playerlist[userid]['ishltv']), playerlist)

    # What to do to the Tv?!
    if not tv:
        # Turn On the Tv :>
        es.server.queuecmd('tv_enable 1')

        # Restart map.
        gamethread.delayed(3, es.server.queuecmd, 'changelevel %s' % es.ServerVar('eventscripts_currentmap'))

        # Send message.
        for i in range(0, 3):
            msg(Language('warning sourcetv on', {}, str(gw_language)))
    else:
        # Turn Off the Tv :c
        es.server.queuecmd('tv_enable 0')
        es.server.queuecmd('tv_stop')

        # Send message.
        for i in range(0, 3):
            msg(Language('warning sourcetv off', {}, str(gw_language)))
''' ; end - SourceTv_Manager() ; '''

'''
| Func:  SourceTv_StartRec()
|
|   ->  This function records demos with SourceTv.
|
'''
def SourceTv_StartRec():
    # Variables.
    playerlist = es.createplayerlist()
    SourceTv = filter(lambda userid: int(playerlist[userid]['ishltv']), playerlist)

    # Check SourceTv status.
    if SourceTv:
        # Demo name.
        filename = time.strftime("%d-%m-%Y_%H-%M-%S", time.localtime()) + '_' + es.ServerVar('eventscripts_currentmap') + '_' + Store['team1']['name'] + '_vs_' + Store['team2']['name']

        # String replacement.
        filename = filename.replace(' ', '_')

        # Save demo name.
        DataSet('demo', filename)

        # Start recording.
        es.server.queuecmd('tv_record "cfg/%s/demos/%s"' % (info['basename'], filename))

        # Send message.
        msg(Language('sourcetv recording', {}, str(gw_language)))
        msg('#g%s.dem' % filename)
''' ; end - SourceTv_StartRec() ; '''

'''
| Func:  SourceTv_StopRec()
|
|   ->  This function stops recording demos with SourceTv.
|
'''
def SourceTv_StopRec():
    # Variables.
    playerlist = es.createplayerlist()
    SourceTv = filter(lambda userid: int(playerlist[userid]['ishltv']), playerlist)

    # Remove the demo name.
    DataSet('demo', '')
    
    # Check SourceTv status.
    if SourceTv:
        # Stop recording.
        es.server.queuecmd('tv_stoprecord')

        # Send message.
        msg(Language('sourcetv stop', {}, str(gw_language)))
        msg('#g%s.dem' % Store['demo'])
''' ; end - SourceTv_StopRec ; '''

'''
| Func:  WarAdmin()
|
|   ->  This opens the admin menu, or not...
|
'''
def WarAdmin():
    # Variables.
    uid = int(es.getcmduserid())
    sid = es.getplayersteamid(uid)

    # Are we admin?
    if IsAdmin(sid):
        # Yes we are, send admin menu.
        WarMenus(uid)
    else:
        # Don't have access.
        tell(uid, Language('error not authorized', {}, str(gw_language)))
''' ; end - WarAdmin() ; '''

'''
| Funcao:  IsAdmin()
|
|   ->  This function checks if a user is admin!
|
'''
def IsAdmin(sid):
    if sid in Admins: return 1
    return 0
''' ; end - IsAdmin() ; '''

'''
| Func:  ResetPlayers()
|
|   ->  This function reset's all player status.
|
'''
def ResetPlayers():
    # Reset..
    for uid in Players:
        Players[uid] = 0
''' ; end - ResetPlayers() ; '''

'''
| Func:  WarStart()
|
|   ->  This function start's a war.
|
'''
def WarStart():
    # Variables.
    uid = int(es.getcmduserid())
    sid = es.getplayersteamid(uid)

    # Are we admin?
    if IsAdmin(sid):
        # See if a war is not active.
        if int(Store['active']) == 0:
            # See if Ready System is not active.
            if int(Store['rsystem']) == 0:
                # Resets.
                DataReset()
                ResetPlayers()

                # Check teams TAGs and Save it.
                Store['team1']['name'] = TagChecker('t')
                Store['team2']['name'] = TagChecker('ct')

                # Send message.
                tokens = {}
                tokens['team1'] = Store['team1']['name']
                tokens['team2'] = Store['team2']['name']
                msg(Language('war start', tokens, str(gw_language)))

                # Ready System.
                readySystem()
            else:
                # Send message.
                tell(uid, Language('error not possible start', {}, str(gw_language)))
        else:
            # Send message.
            tell(uid, Language('error not possible start', {}, str(gw_language)))
    else:
        # Don't have access.
        tell(uid, Language('error not authorized', {}, str(gw_language)))
''' ; end - WarStart() ; '''

'''
| Func:  WarStartKO3()
|
|   ->  This function start's a knife fight.
|
'''
def WarStartKO3():
    # Variables.
    uid = int(es.getcmduserid())
    sid = es.getplayersteamid(uid)

    # Are we admin?
    if IsAdmin(sid):
        # Send message.
        msg(Language('war start ko3', {}, str(gw_language)))

        # Knives On 3.
        gamethread.delayed(2, KO3)
    else:
        # Don't have access.
        tell(uid, Language('error not authorized', {}, str(gw_language)))
''' ; end - WarStartKO3() ; '''

'''
| Func:  WarReStart()
|
|   ->  This restarts a war.
|
'''
def WarReStart():
    # Variables.
    uid = int(es.getcmduserid())
    sid = es.getplayersteamid(uid)

    # Are we admin?
    if IsAdmin(sid):
        # See if a war is active.
        if int(Store['active']) == 1:
            # Resets.
            DataReset(1)

            # Send message.
            for i in range(0, 3):
                msg(Language('war restart', {}, str(gw_language)))

            # Live On 3.
            gamethread.delayed(2, LO3)
        else:
            tell(uid, Language('error not possible restart', {}, str(gw_language)))
    else:
        # Don't have access.
        tell(uid, Language('error not authorized', {}, str(gw_language)))
''' ; end - WarReStart() ; '''




'''
| Func:  WarForce()
|
|   ->  This functions froces a war to start.
|
'''
def WarForce():
    # Variables.
    uid = int(es.getcmduserid())
    sid = es.getplayersteamid(uid)

    # Are we admin?
    if IsAdmin(sid):
        # See if a war is not active.
        if int(Store['active']) == 0:

            # 
            #
            #   VERIFY IF THE READY SYSTEM IS ACTIVATED...
            #
            #


            # Resets.
            DataReset()
            ResetPlayers()

            # Check teams TAGs and Save it.
            Store['team1']['name'] = TagChecker('t')
            Store['team2']['name'] = TagChecker('ct')

            # Send message.
            tokens = {}
            tokens['admin'] = es.getplayername(uid)
            msg(Language('war forced', tokens, str(gw_language)))

            # Send message 2.
            tokens = {}
            tokens['team1'] = Store['team1']['name']
            tokens['team2'] = Store['team2']['name']
            gamethread.delayed(2, msg, Language('war start', tokens, str(gw_language)))

            # Ready System.
            gamethread.delayed(4, LO3)
        else:
            # Send message.
            tell(uid, Language('error not possible start', {}, str(gw_language)))
    else:
        # Don't have access.
        tell(uid, Language('error not authorized', {}, str(gw_language)))
''' ; end - WarForce() ; '''




'''
| Func:  WarCancel()
|
|   ->  This function cancels an active war!
|
'''
def WarCancel():
    # Variables.
    uid   = int(es.getcmduserid())
    sid   = es.getplayersteamid(uid)
    admin = es.getplayername(uid)

    # Are we admin?
    if IsAdmin(sid):
        # Check if the Knife Round is active
        if int(Store['active']) == 1 and int(Store['mode']) == 1:
            # Enable Buyzones...
            for uid in playerlib.getUseridList('#all,#human'):
                Knife(uid, False)
                Store['active'] = 0
                Store['mode'] = 0

            # Restart Round.
            gamethread.delayed(1, es.server.queuecmd, 'mp_restartgame 1')

        # See if a war is not active.
        elif int(Store['active']) == 0 or int(Store['rsystem']) == 0:
            # Send message.
            msg(Language('war cancel', {'admin':admin}, str(gw_language)))

            # Stop recording.
            SourceTv_StopRec()

            # Reset Data.
            DataReset()

            # Change server's hostname and restart round.
            gamethread.delayed(1, es.server.queuecmd, 'hostname %s' % gw_hostname)
            gamethread.delayed(1, es.server.queuecmd, 'mp_restartgame 1')

        # Otherwise...
        else:
            # Send message.
            tell(uid, Language('error not possible cancel', {}, str(gw_language)))
    else:
        # Don't have access.
        tell(uid, Language('error not authorized', {}, str(gw_language)))
''' ; end - WarCancel() ; '''

'''
| Func:  SayScore()
|
|   ->  This function says the current war score.
|
'''
def SayScore(userid = False):
    # Variables.
    name1  = Store['team1']['name']
    name2  = Store['team2']['name']
    score1 = Store['team1']['score']
    score2 = Store['team2']['score']

    # See what to send.
    if score1 == score2:
        # Prepare message.
        tokens = {}
        tokens['team1']   = name1
        tokens['result1'] = score1
        tokens['team2']   = name2
        tokens['result2'] = score2
        text = Language('score tied', tokens, str(gw_language))
    else:
        # Result.
        if score1 > score2:
            result1 = score1
            result2 = score2
        elif score1 < score2:
            result1 = score2
            result2 = score1

        # Prepare message.
        tokens = {}
        tokens['team']    = name1 if score1 > score2 else name2
        tokens['result1'] = result1
        tokens['result2'] = result2
        text = Language('score win', tokens, str(gw_language))

    # Send message to who?!
    if userid:
        tell(userid, text)
    else:
        msg(text)
''' ; end - SayScore() ; '''

'''
| Func:  ChatFilter()
|
|   ->  Chat filter, the name says all.
|
|
'''
def ChatFilter(uid, text, teamonly):
    # Variables
    text     = text.strip('"')
    UserID   = int(uid)
    SteamID  = es.getplayersteamid(UserID)
    Username = es.getplayername(UserID)


    # ~~~~~~~~~~~~~~~~~
    # Admin Talk
    if text.startswith('"%s ' % gw_chat_prefix) or text.startswith('%s ' % gw_chat_prefix):
        # Variables.
        text = text.replace('"', '')
        text = text.replace('%s ' % gw_chat_prefix, ' ')

        # Check if the user has access.
        if SteamID in Admins:
            # Talk globally or team only?
            if teamonly == 0:
                # Variables.
                player = playerlib.getPlayer(UserID)
                index  = player.attributes['index']

                # Send message.
                usermsg.saytext2('#all', index, '\x03%s \x04~ \x01%s' % (Username, text))
            else:
                # Team only.
                pl = playerlib.getUseridList('#all,#human')
                for pUserID in pl:
                    pSteamID = es.getplayersteamid(pUserID)
                    player   = playerlib.getPlayer(UserID)
                    index    = player.attributes['index']
                    if pSteamID in Admins:
                        usermsg.saytext2(pUserID, index, '\x03%s \x01[TO TEAM] \x04~ \x01%s' % (Username, text))
        else:
            # Send message to admins online.
            pl = playerlib.getUseridList('#all,#human')
            for pUserID in pl:
                pSteamID = es.getplayersteamid(pUserID)
                player   = playerlib.getPlayer(UserID)
                index    = player.attributes['index']
                if pSteamID in Admins:
                    usermsg.saytext2(pUserID, index, '\x03%s \x01[TO ADMIN] \x04~ \x01%s' % (Username, text))

            # Show message to the player.
            usermsg.saytext2(UserID, index, '\x03%s \x01[TO ADMIN] \x04~ \x01%s' % (Username, text))

        # Don't return the message.
        return(0, None, None)
        # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # TV Connect
    elif text in [ '.tv', '/tv', '!tv' ]:
        tell(UserID, Language('connect sourcetv', {'connect':gw_sourcetv_addr}, str(gw_language)))
        return(0, None, None)
    # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # Mark as ready
    elif text in [ '.r', '/r', '!r' ]:
        if Store['rsystem']:
            if Players[UserID]:
                tell(UserID, Language('rsys you marked allready', {}, str(gw_language)))
            else:
                Players[UserID] = 1
                msg(Language('rsys marked', {'user': Username}, str(gw_language)))
                tell(UserID, Language('rsys you marked', {}, str(gw_language)))
                readySystem()
        else:
            tell(UserID, Language('error not active', {}, str(gw_language)))
        return(0, None, None)
    # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # Mark as not ready.
    elif text in [ '.ur', '/ur', '!ur' ]:
        if Store['rsystem']:
            if Players[UserID]:
                Players[UserID] = 0
                msg(Language('rsys not marked', {'user': Username}, str(gw_language)))
                tell(UserID, Language('rsys you not marked', {}, str(gw_language)))
                readySystem()
            else:
                tell(UserID, Language('rsys you were not marked', {}, str(gw_language)))
        else:
            tell(UserID, Language('error not active', {}, str(gw_language)))
        return(0, None, None)
    # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # Show teams score.
    elif text in [ '.score', '/score', '!score' ]:
        if int(Store['active']) == 1:
            SayScore(UserID)
        else:
            tell(UserID, Language('error not active', {}, str(gw_language)))
        return(0, None, None)
    # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # Shows the ready system menu if active.
    elif text in [ '.info', '/info', '!info' ]:
        if int(Store['rsystem']) == 1:
            #MenuReady.unsend(UserID)
            MenuReady.send(UserID)
        else:
            tell(UserID, Language('error not active', {}, str(gw_language)))
        return(0, None, None)
    # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # If public chat is turned off
    if int(gw_chat) == 0:
        # If the player is not dead, sends his messages only to his team mates.
        if not int(playerlib.getPlayer(UserID).attributes['isdead']):
            return(UserID, text, True)
    
        # If dead, can we talk to the other team?
        if not int(gw_chat_dead):
            return(0, None, None)
        # ~~~~~~~~~~~~~~~~~


    # ~~~~~~~~~~~~~~~~~
    # Other text... return it :)
    return(UserID, text, teamonly)
''' ; end ; '''

'''
| Func:  Knife()
|
|   ->  This function is only used on the knife round.
|
|   @params - uid       integer
|   @params - opt       boolean
|
'''
def Knife(uid, opt):
    uid = int(uid)
    # Disable or Enable?
    if opt:
        # Disable.
        es.server.queuecmd('es_xfire %i func_buyzone disable' % uid)
        es.server.queuecmd('es_xfire %i func_bomb_target disable' % uid)
        es.server.queuecmd('es_xfire %i func_hostage_rescue disable' % uid)
        es.server.queuecmd('es_xfire %i player_weaponstrip Kill' % uid)
        es.server.queuecmd('es_xgive %i player_weaponstrip' % uid)
        es.server.queuecmd('es_xfire %i player_weaponstrip Strip' % uid)
        es.server.queuecmd('es_xgive %i item_assaultsuit' % uid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %i weapon_knife' % uid)
    else:
        # Enable.
        es.server.queuecmd('es_xfire %i func_buyzone enable' % uid)
        es.server.queuecmd('es_xfire %i func_bomb_target enable' % uid)
        es.server.queuecmd('es_xfire %i func_hostage_rescue enable' % uid)
''' ; end - Knife() ; '''

'''
| Func:  DataSet()
|
|   ->  This functions edits the values in the data Dict.
|
|   @params - key       integer
|   @params - value     integer
|
'''
def DataSet(key, value):
    # Edit the value.
    Store[key] = value
''' ; end - DataSet() ; '''

'''
| Func:  DataReset()
|
|   ->  This function resets the Data Dict.
|
|   @params - mode      integer
|
''' 
def DataReset(mode = 0):
    # Global variable, just in case...
    global Store

    # Variables.
    team1 = Store['team1']['name']
    team2 = Store['team2']['name']
    demo  = Store['demo']

    # mode :: 0-Normal |  1-Re-LiveOn3  |  2-OverTime
    if mode == 1:
        Store['swaps'] += 1
        swaps = Store['swaps']
        t1 = team2 if swaps == 1 else team1
        t2 = team1 if swaps == 1 else team2
        Store = {'active': 0, 'rsystem': 0, 'swaps': swaps, 'oswaps': 0, 'rounds': 0, 'mode': 0, 'team1': { 'name': t1, 'score': 0 }, 'team2': { 'name': t2, 'score': 0 }, 'demo': demo}
    elif mode == 2:
        Store['oswaps'] += 1
        swaps = Store['oswaps']
        t1 = team1 if swaps % 2 == 0 else team2
        t2 = team2 if swaps % 2 == 0 else team1
        Store = {'active': 0, 'rsystem': 0, 'swaps': 0, 'oswaps': swaps, 'rounds': 0, 'mode': 2, 'team1': { 'name': t1, 'score': 0 }, 'team2': { 'name': t2, 'score': 0 }, 'demo': demo}
    else:
        Store = {'active': 0, 'rsystem': 0, 'swaps': 0, 'oswaps': 0, 'rounds': 0, 'mode': 0, 'team1': { 'name': 'Team 1', 'score': 0 }, 'team2': { 'name': 'Team 2', 'score': 0 }, 'demo': ''}
''' ; end ; '''

'''
|
|
|
|
'''
def readySystem():
    # If Ready System is enabled.
    if int(gw_ready_sys):
        # Turn it on.
        Store['rsystem'] = 1

        # Make it ready, just in case.
        ready = 1

        # Check all players status.
        for uid in Players:
            # UserID.
            UserID = int(uid)

            # Make it not ready.
            if Players[UserID] == 0:
                if CheckTeam(UserID, 2):
                    ready = 0
                else:
                    tell(UserID, Language('rsys no team', {}, str(gw_language)))

        # If we are still awating for someone to get ready, shows the popup.
        if not ready:
            myPopups['wm_rsystem'] = popuplib.Popup('wm_rsystem')
            myPopups['wm_rsystem'].append('WarMod - Ready System')
            myPopups['wm_rsystem'].append(' ')
            myPopups['wm_rsystem'].append('PCW : %s vs %s'%(Store['team1']['nome'], Store['team2']['nome']))
            myPopups['wm_rsystem'].append(' ')
            myPopups['wm_rsystem'].append('->1. Quem nao esta pronto:')
            myPopups['wm_rsystem'].append(' ')
            for uid in Players:
                if CheckTeam(uid, 1):
                    if not Players[uid]:
                        myPopups['wm_rsystem'].append('  %s' % es.getplayername(uid))
            myPopups['wm_rsystem'].append(' ')
            myPopups['wm_rsystem'].append(' ')
            myPopups['wm_rsystem'].append('->0. %s' % Language('popups close', {}, str(gw_language)))
            myPopups['wm_rsystem'].menuselect = readySystemMen

            ''' Enviar o menu a todos os jogadores. '''
            for uid in Players:
                userid = int(uid)
                #myPopups['wm_rsystem'].unsend(userid)
                myPopups['wm_rsystem'].send(userid)
        else:
            ''' Definir o Ready System como desactivado. '''
            Store['rsystem'] = 0

            ''' Ver qual Live vamos dar, Se KNIFE ou LIVE '''
            if Store['mode'] == 1:
                gamethread.delayed(2, KO3)
            else:
                gamethread.delayed(2, LO3)
    else:
        ''' Ver qual Live vamos dar, Se KNIFE ou LIVE '''
        if Store['mode'] == 1:
            gamethread.delayed(2, KO3)
        else:
            gamethread.delayed(2, LO3)
''' ; end ; '''


def readySystemMen(userid, choice, popupid):
    if choice > 0:
        dotr.send(userid)




#def KO3:
def KO3():
    # Change server hostname.
    #hostname = str(gw_hostname_war)
    #if '$team1' in hostname: hostname = hostname.replace('$team1', Store['team1']['name'])
    #if '$team2' in hostname: hostname = hostname.replace('$team2', Store['team2']['name'])
    #es.server.queuecmd('hostname "%s"' % hostname)    

    # See if the war is active, maybe an error occurred.
    if int(Store['active']) == 1:
        Store['active'] = 0
        Store['mode'] = 0

    # Start Recording.
    if int(gw_sourcetv_autorec_ko3) == 1:
        SourceTv_StartRec()

    # Knives On 3 process messages.
    gamethread.delayed(1, msg, ('#dgWarMod #d~ #lKnifes on 3 Restarts'))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(2, es.server.queuecmd, 'mp_restartgame 1')
    gamethread.delayed(3, msg, ('#dgWarMod #d~ #lKnifes on 2 Restarts'))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(4, es.server.queuecmd, 'mp_restartgame 1')
    gamethread.delayed(5, msg, ('#dgWarMod #d~ #lKnifes After Next Restart'))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(6, es.server.queuecmd, 'mp_restartgame 1')
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lKNIFES!!!'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lKNIFES!!!'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lKNIFES!!!'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lGood Knifing'))
    gamethread.delayed(6, DataSet, ('active', 1))
    gamethread.delayed(6, DataSet, ('mode', 1))
''' ; end ; '''


'''
| Func:  LO3()
|
|   ->  This function executes the Live On 3 process.
|
'''
def LO3():
    # Change server hostname.
    hostname = str(gw_hostname_war)
    if '$team1' in hostname: hostname = hostname.replace('$team1', Store['team1']['name'])
    if '$team2' in hostname: hostname = hostname.replace('$team2', Store['team2']['name'])
    es.server.queuecmd('hostname "%s"' % hostname)   

    # Check if the Knife Round is active
    if int(Store['active']) == 1 and int(Store['mode']) == 1:
        for uid in playerlib.getUseridList('#all,#human'):
            Knife(uid, False)
            Store['active'] = 0
            Store['mode'] = 0

    # Start Recording.
    if int(gw_sourcetv_autorec_lo3) == 1:
        SourceTv_StartRec()

    # Live On 3 process messages.
    gamethread.delayed(1, msg, ('#dgWarMod #d~ #lLive on 3 Restarts'))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(1, msg, (' '))
    gamethread.delayed(2, es.server.queuecmd, 'mp_restartgame 1')
    gamethread.delayed(3, msg, ('#dgWarMod #d~ #lLive on 2 Restarts'))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(3, msg, (' '))
    gamethread.delayed(4, es.server.queuecmd, 'mp_restartgame 1')
    gamethread.delayed(5, msg, ('#dgWarMod #d~ #lLive After Next Restart'))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(5, msg, (' '))
    gamethread.delayed(6, es.server.queuecmd, 'mp_restartgame 1')
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lMatch is Live'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lMatch is Live'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lMatch is Live'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lMatch is Live'))
    gamethread.delayed(7, msg, ('#dgWarMod #d~ #lGood Luck and Have Fun'))
    gamethread.delayed(8, DataSet, ('active', 1))
''' ; end - LO3() ; '''



'''
==============================================================================
   POPUPS
==============================================================================
'''

'''
| Func: closePopups()
|
|   ->  This function closes all other popups that are opened.
|
'''
def closePopups(uid):
    count = popuplib.active(uid)['count']
    while count > 0:
        count -= 1
        popuplib.close(popuplib.active(uid)['name'], uid)
''' ; end - closePopups() ; '''


'''
| Func:  WarMenus()
|
|   -> This function creates all the necessary menus for war management.
|
'''
def WarMenus(userid, menu = False, admins = False):
    # Close all other popups.
    closePopups(userid)

    # Create all the needed popups.
    myPopups['wm_men0']     = popuplib.easymenu('wm_men0',     None, PopupGest)
    myPopups['wm_men1']     = popuplib.easymenu('wm_men1',     None, PopupGest)
    myPopups['wm_men2']     = popuplib.easymenu('wm_men2',     None, PopupGest)
    myPopups['wm_men3']     = popuplib.easymenu('wm_men3',     None, ChangeConfig)
    myPopups['wm_men4']     = popuplib.easymenu('wm_men4',     None, ChangePassword)
    myPopups['wm_men5']     = popuplib.easymenu('wm_men5',     None, ChangeMap)
    myPopups['wm_men6']     = popuplib.easymenu('wm_men6',     None, PopupGest)
    myPopups['wm_men6.1']   = popuplib.easymenu('wm_men6.1',   None, PopupGest)
    myPopups['wm_men6.1.1'] = popuplib.easymenu('wm_men6.1.1', None, Kick)
    myPopups['wm_men6.2']   = popuplib.easymenu('wm_men6.2',   None, PopupGest)
    myPopups['wm_men6.2.1'] = popuplib.easymenu('wm_men6.2.1', None, Ban)
    myPopups['wm_men6.3']   = popuplib.easymenu('wm_men6.3',   None, Unban)
    myPopups['wm_men6.4']   = popuplib.easymenu('wm_men6.4',   None, SwapTeam)
    myPopups['wm_men6.6']   = popuplib.easymenu('wm_men6.6',   None, PopupGest)
    myPopups['wm_men6.6.1'] = popuplib.easymenu('wm_men6.6.1', None, SwapSpec)
    myPopups['wm_men7']     = popuplib.easymenu('wm_men7',     None, PopupGest)

    # Popup 0 : Main popup
    myPopups['wm_men0'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men0'].setdescription(' ')
    myPopups['wm_men0'].addoption('wm_men1', Language('popup line1', {}, str(gw_language)))
    myPopups['wm_men0'].addoption('wm_men2', Language('popup line2', {}, str(gw_language)))
    myPopups['wm_men0'].addoption('wm_men3', Language('popup line3', {}, str(gw_language)))
    myPopups['wm_men0'].addoption('wm_men4', Language('popup line4', {}, str(gw_language)))
    myPopups['wm_men0'].addoption('wm_men5', Language('popup line5', {}, str(gw_language)))
    myPopups['wm_men0'].addoption('wm_men6', Language('popup line6', {}, str(gw_language)))
    myPopups['wm_men0'].addoption('wm_men7', Language('popup line7', {}, str(gw_language)))
    myPopups['wm_men0'].c_exitformat = '0. %s' % Language('popups close', {}, str(gw_language))

    # Popup 1 : WarMod Commands
    myPopups['wm_men1'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men1'].setdescription(':: %s' % Language('popup line1', {}, str(gw_language)))
    # Live On 3
    if int(Store['active']) == 0:
        myPopups['wm_men1'].addoption('lo3',  Language('popup line1.1', {}, str(gw_language)))
    else:
        myPopups['wm_men1'].addoption('lo3',  Language('popup line1.1', {}, str(gw_language)), False)

    # Re-Lo3
    if int(Store['active']) == 1 and int(Store['mode']) in [ 0 , 2 ]:
        myPopups['wm_men1'].addoption('rlo3', Language('popup line1.2', {}, str(gw_language)))
    else:
        myPopups['wm_men1'].addoption('rlo3', Language('popup line1.2', {}, str(gw_language)), False)

    # Force
    if int(Store['active']) == 0 and int(Store['rsystem']) == 1:
        myPopups['wm_men1'].addoption('flo3', Language('popup line1.3', {}, str(gw_language)))
    else:
        myPopups['wm_men1'].addoption('flo3', Language('popup line1.3', {}, str(gw_language)), False)

    # Knife...
    if int(Store['active']) == 0:
        myPopups['wm_men1'].addoption('ko3',  Language('popup line1.4', {}, str(gw_language)))
    else:
        myPopups['wm_men1'].addoption('ko3',  Language('popup line1.4', {}, str(gw_language)), False)

    # Cancel...
    if int(Store['active']) == 1:
        myPopups['wm_men1'].addoption('cwar', Language('popup line1.5', {}, str(gw_language)))
    else:
        myPopups['wm_men1'].addoption('cwar', Language('popup line1.5', {}, str(gw_language)), False)

    myPopups['wm_men1'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men1'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))


    # Popup 2 : Server Commands
    myPopups['wm_men2'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men2'].setdescription(':: %s' % Language('popup line2', {}, str(gw_language)))
    myPopups['wm_men2'].addoption('rr', Language('popup line2.1', {}, str(gw_language)))
    myPopups['wm_men2'].addoption('rm', Language('popup line2.2', {}, str(gw_language)))
    myPopups['wm_men2'].addoption('rs', Language('popup line2.3', {}, str(gw_language)))
    myPopups['wm_men2'].addoption('vr', Language('popup line2.4', {}, str(gw_language)))
    myPopups['wm_men2'].addoption('pc', '%s - %s' % ('[x]' if int(gw_chat) == 1 else '[  ]' , Language('popup line2.5', {}, str(gw_language))))
    myPopups['wm_men2'].addoption('at', '%s - %s' % ('[x]' if int(es.ServerVar('sv_alltalk')) == 1 else '[  ]', Language('popup line2.6', {}, str(gw_language))))
    myPopups['wm_men2'].addoption('rs', '%s - %s' % ('[x]' if int(gw_ready_sys) == 1 else '[  ]', Language('popup line2.7', {}, str(gw_language))))
    myPopups['wm_men2'].addoption('op', '%s - %s' % ('[x]' if int(gw_opoints) == 1 else '[  ]', Language('popup line2.8', {}, str(gw_language))))
    myPopups['wm_men2'].addoption('rb', '%s - %s' % ('[x]' if int(gw_ragdolls)== 1 else '[  ]', Language('popup line2.9', {}, str(gw_language))))
    myPopups['wm_men2'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men2'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 3 : Config Files
    myPopups['wm_men3'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men3'].setdescription(':: %s' % Language('popup line3', {}, str(gw_language)))
    for cfg in Configs: myPopups['wm_men3'].addoption(Configs[cfg], cfg)
    myPopups['wm_men3'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men3'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 4 : Server Password
    myPopups['wm_men4'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men4'].setdescription(':: %s' % Language('popup line4', {}, str(gw_language)))
    myPopups['wm_men4'].addoption('none', Language('no password', {}, str(gw_language)))
    for pw in Passwords: myPopups['wm_men4'].addoption(pw, pw)
    myPopups['wm_men4'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men4'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 5 : Map management
    myPopups['wm_men5'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men5'].setdescription(':: %s' % Language('popup line5', {}, str(gw_language)))
    for m in Maps: myPopups['wm_men5'].addoption(m, m)
    myPopups['wm_men5'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men5'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 6 : Player Management
    myPopups['wm_men6'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6'].setdescription(':: %s' % Language('popup line6', {}, str(gw_language)))
    myPopups['wm_men6'].addoption('wm_men6.1', Language('popup line6.1', {}, str(gw_language)))
    myPopups['wm_men6'].addoption('wm_men6.2', Language('popup line6.2', {}, str(gw_language)))
    myPopups['wm_men6'].addoption('wm_men6.3', Language('popup line6.3', {}, str(gw_language)))
    myPopups['wm_men6'].addoption('wm_men6.4', Language('popup line6.4', {}, str(gw_language)))
    myPopups['wm_men6'].addoption('wm_men6.5', Language('popup line6.5', {}, str(gw_language)))
    myPopups['wm_men6'].addoption('wm_men6.6', Language('popup line6.6', {}, str(gw_language)))
    myPopups['wm_men6'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men6'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 6.1 : Player Management > Kick
    myPopups['wm_men6.1'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.1'].setdescription(':: %s > %s' % (Language('popup line6', {}, str(gw_language)), Language('popup line6.1', {}, str(gw_language))))
    myPopups['wm_men6.1'].addoption('ind',  Language('popup line cp', {}, str(gw_language)))
    myPopups['wm_men6.1'].addoption('all',  Language('popup line ap', {}, str(gw_language)))
    myPopups['wm_men6.1'].addoption('ct',   Language('popup line act', {}, str(gw_language)))
    myPopups['wm_men6.1'].addoption('t',    Language('popup line at', {}, str(gw_language)))
    myPopups['wm_men6.1'].addoption('spec', Language('popup line asp', {}, str(gw_language))) 
    myPopups['wm_men6.1'].submenu(9, myPopups['wm_men6'])
    myPopups['wm_men6.1'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Menu 6.1.1 : Player Management > Kick > Choose a Player
    myPopups['wm_men6.1.1'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.1.1'].setdescription(':: %s > %s' % (Language('popup line6.1', {}, str(gw_language)), Language('popup line cp', {}, str(gw_language))))
    for id in playerlib.getUseridList('#all,#human'): myPopups['wm_men6.1.1'].addoption(id, es.getplayername(id))
    myPopups['wm_men6.1.1'].submenu(9, myPopups['wm_men6.1'])
    myPopups['wm_men6.1.1'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 6.2 : Player Management > Ban
    myPopups['wm_men6.2'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.2'].setdescription(':: %s > %s' % (Language('popup line6', {}, str(gw_language)), Language('popup line6.2', {}, str(gw_language))))
    myPopups['wm_men6.2'].addoption('ind',  Language('popup line cp', {}, str(gw_language)))
    myPopups['wm_men6.2'].addoption('all',  Language('popup line ap', {}, str(gw_language)))
    myPopups['wm_men6.2'].addoption('ct',   Language('popup line act', {}, str(gw_language)))
    myPopups['wm_men6.2'].addoption('t',    Language('popup line at', {}, str(gw_language)))
    myPopups['wm_men6.2'].addoption('spec', Language('popup line asp', {}, str(gw_language)))   
    myPopups['wm_men6.2'].submenu(9, myPopups['wm_men6'])
    myPopups['wm_men6.2'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))    

    # Menu 6.2.1 : Player Management > Ban > Choose a Player
    myPopups['wm_men6.2.1'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.2.1'].setdescription(':: %s > %s' % (Language('popup line6.2', {}, str(gw_language)), Language('popup line cp', {}, str(gw_language))))
    for id in playerlib.getUseridList('#all,#human'): myPopups['wm_men6.2.1'].addoption(id, es.getplayername(id))
    myPopups['wm_men6.2.1'].submenu(9, myPopups['wm_men6.2'])
    myPopups['wm_men6.2.1'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Menu 6.3 : Player Management > UnBan
    myPopups['wm_men6.3'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.3'].setdescription(':: %s > %s' % (Language('popup line6', {}, str(gw_language)), Language('popup line6.3', {}, str(gw_language))))
    #
    #   TODO!!
    #
    myPopups['wm_men6.3'].submenu(9, myPopups['wm_men6'])
    myPopups['wm_men6.3'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Menu 6.4 : Player Management > Swap Player
    myPopups['wm_men6.4'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.4'].setdescription(':: %s > %s' % (Language('popup line6', {}, str(gw_language)), Language('popup line6.4', {}, str(gw_language))))
    for id in playerlib.getUseridList('#all,#human'): myPopups['wm_men6.4'].addoption(id, '%s %s' % (CheckTeam(id, 3), es.getplayername(id)))
    myPopups['wm_men6.4'].submenu(9, myPopups['wm_men6'])
    myPopups['wm_men6.4'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 6.6 : Player Management > Swap to Spectator
    myPopups['wm_men6.6'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.6'].setdescription(':: %s > %s' % (Language('popup line6', {}, str(gw_language)), Language('popup line6.6', {}, str(gw_language))))
    myPopups['wm_men6.6'].addoption('ind',  Language('popup line cp', {}, str(gw_language)))
    myPopups['wm_men6.6'].addoption('all',  Language('popup line ap', {}, str(gw_language)))
    myPopups['wm_men6.6'].addoption('ct',   Language('popup line act', {}, str(gw_language)))
    myPopups['wm_men6.6'].addoption('t',    Language('popup line at', {}, str(gw_language)))
    myPopups['wm_men6.6'].submenu(9, myPopups['wm_men6'])
    myPopups['wm_men6.6'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))    

    # Popup 6.6.1 : Player Management > Swap to Spectator > Choose a Player
    myPopups['wm_men6.6.1'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men6.6.1'].setdescription(':: %s > %s' % (Language('popup line6.6', {}, str(gw_language)), Language('popup line cp', {}, str(gw_language))))
    for id in playerlib.getUseridList('#all,#human'): myPopups['wm_men6.6.1'].addoption(id, es.getplayername(id)) 
    myPopups['wm_men6.6.1'].submenu(9, myPopups['wm_men6.6'])
    myPopups['wm_men6.6.1'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Popup 7 : SourceTv Management
    playerlist = es.createplayerlist()
    myPopups['wm_men7'].settitle(Language('popups title', {}, str(gw_language)))
    myPopups['wm_men7'].setdescription(':: %s ' % Language('popup line7', {}, str(gw_language)))

    if not filter(lambda userid: int(playerlist[userid]['ishltv']), playerlist):
        myPopups['wm_men7'].addoption('1',  Language('popup line7.1 on', {}, str(gw_language)))
    else:
        myPopups['wm_men7'].addoption('1',  Language('popup line7.1 off', {}, str(gw_language)))

    myPopups['wm_men7'].addoption('2',  Language('popup line7.2 %s' % ('on' if Store['demo'] == '' else 'off'), {}, str(gw_language)))

    myPopups['wm_men7'].addoption('autoreclo3', '%s - %s' % ('[x]' if int(gw_sourcetv_autorec_lo3) == 1 else '[  ]', Language('popup line7.3', {}, str(gw_language))))
    myPopups['wm_men7'].addoption('autorecko3', '%s - %s' % ('[x]' if int(gw_sourcetv_autorec_ko3) == 1 else '[  ]', Language('popup line7.4', {}, str(gw_language))))
    myPopups['wm_men7'].submenu(9, myPopups['wm_men0'])
    myPopups['wm_men7'].c_exitformat = '0. %s' % Language('popups back', {}, str(gw_language))

    # Send 'men1' or what?
    if not menu:
        myPopups['wm_men0'].send(userid)
    else:
        myPopups[menu].send(userid)
''' ; end ; '''

'''
| Func:  PopupGest()
|
|   ->  This function handles the popups.
|
'''
def PopupGest(userid, choice, popup):
    # Variables.
    userid    = int(userid)
    #choice    = params['choice']
    popupname = popup

    # ~~~~~~~~~~~~~~~~~
    # Popup1 : War Commands
    if popupname == 'wm_men1':
        # LO3 = Live On 3
        if choice == 'lo3':
            WarStart()

            # Save the log.
            LogSave(userid, 'Live On 3')

        # KO3 = Knife On 3
        elif choice == 'ko3':
            WarStartKO3()

            # Save the log.
            LogSave(userid, 'Knives On 3')

        # RE-LO3 = Dar live novamente...
        elif choice == 'rlo3':
            WarReStart()

            # Save the log.
            LogSave(userid, 'Re-Live On 3')

        # F-LO3 = Forcar a iniciar..
        elif choice == 'flo3':
            WarForce()

            # Save the log.
            LogSave(userid, 'Forced Live On 3')

        # C-WAR = Cancelar a war..
        elif choice == 'cwar':
            WarCancel()

            # Save the log.
            LogSave(userid, 'Canceled a War')

            # Send menu.
            WarMenus(userid, 'wm_men1')


    # ~~~~~~~~~~~~~~~~~
    # Popup2 : Server Commands
    elif popupname == 'wm_men2':
        # Admin username.
        admin = es.getplayername(userid)

        # 1 : Restart round.
        if choice == 'rr':
            # See if a war is not active.
            if int(Store['active']) == 0:
                # Send messages.
                for i in range(0, 3):
                    msg(Language('restart round', {}, str(gw_language)))

                # Save the log.
                LogSave(userid, 'Restarted Round')

                # Restart round.
                es.server.queuecmd('mp_restartgame 2')

                # Send menu.
                myPopups['wm_men2'].send(userid)
            else:
                # Send message.
                tell(userid, Language('error active', {}, str(gw_language)))

        # 2 : Restart map
        elif choice == 'rm':
            # See if a war is not active.
            if int(Store['active']) == 0:
                # Send messages.
                for i in range(0, 3):
                    msg(Language('restart map', {}, str(gw_language)))

                # Save the log.
                LogSave(userid, 'Restarted Map')

                # Restart map.
                gamethread.delayed(3, es.server.queuecmd, 'changelevel %s' % es.ServerVar('eventscripts_currentmap'))
            else:
                # Send message.
                tell(userid, Language('error active', {}, str(gw_language)))

        # 3 : Restart server.
        elif choice == 'rs':
            # See if a war is not active.
            if int(Store['active']) == 0:
                # Send messages.
                for i in range(0, 3):
                    msg(Language('restart server', {}, str(gw_language)))

                # Save the log.
                LogSave(userid, 'Restarted Server')

                # Send second message.
                for i in range(1, 6):
                    gamethread.delayed(8, msg, (Language('restart server2', {}, str(gw_language))))

                # Restart server.
                gamethread.delayed(10, es.server.queuecmd, '_restart')
            else:
                # Send message.
                tell(userid, Language('error active', {}, str(gw_language)))

        # 4 : Check players rates.
        elif choice =='vr':
            rateCheckerGlobal()

            # Save the log.
            LogSave(userid, 'Checked Rates')

            # Send menu.
            myPopups['wm_men2'].send(userid)

        # 5 : Public Chat
        elif choice == 'pc':
            # Variables.
            mod = '[  ]'        if int(es.ServerVar('gw_chat')) else '[x]'
            val = 0             if int(es.ServerVar('gw_chat')) else 1
            act = 'deactivated' if int(es.ServerVar('gw_chat')) else 'activated'

            # Change cvar.
            es.server.queuecmd('gw_chat %i' % val)

            # Save the log.
            LogSave(userid, 'Changed Password:', choice)

            # Send message.
            tokens = {}
            tokens['admin'] = admin
            tokens['act'] = Language(act, {}, str(gw_language))
            tokens['opt'] = Language('popup line2.5', {}, str(gw_language))
            msg(Language('activate option', tokens, str(gw_language)))

            # Edit and Send the popup.
            myPopups['wm_men2'].setoption('pc', '%s - %s' % (mod, Language('popup line2.5', {}, str(gw_language))))
            myPopups['wm_men2'].send(userid)

        # 6 : AllTalk
        elif choice == 'at':
            # Variables.
            mod = '[  ]'        if int(es.ServerVar('sv_alltalk')) else '[x]'
            val = 0             if int(es.ServerVar('sv_alltalk')) else 1
            act = 'deactivated' if int(es.ServerVar('sv_alltalk')) else 'activated'

            # Change cvar.
            es.server.queuecmd('sv_alltalk %s' % val)

            # Save the log.
            #LogSave(userid, 'Changed CVAR Alltalk to', choice)

            # Send message.
            tokens = {}
            tokens['admin'] = admin
            tokens['act'] = Language(act, {}, str(gw_language))
            tokens['opt'] = Language('popup line2.6', {}, str(gw_language))
            msg(Language('activate option', tokens, str(gw_language)))

            # Edit and Send the popup.
            myPopups['wm_men2'].setoption('at', '%s - %s' % (mod, Language('popup line2.6', {}, str(gw_language))))
            myPopups['wm_men2'].send(userid)

        # 7 : Ready System
        elif choice == 'rs':
            # If a war is not active.
            if not Store['active']:
                # Variables.
                mod = '[  ]'        if int(es.ServerVar('gw_ready_sys')) else '[x]'
                val = 0             if int(es.ServerVar('gw_ready_sys')) else 1
                act = 'deactivated' if int(es.ServerVar('gw_ready_sys')) else 'activated'

                # Change cvar.
                es.server.queuecmd('gw_ready_sys %s' % val)

                # Send message.
                tokens = {}
                tokens['admin'] = admin
                tokens['act'] = Language(act, {}, str(gw_language))
                tokens['opt'] = Language('popup line2.7', {}, str(gw_language))
                msgAdmin(Language('activate option', tokens, str(gw_language)))

                # Edit and Send the popup.
                myPopups['wm_men2'].setoption('rs', '%s - %s' % (mod, Language('popup line2.7', {}, str(gw_language))))
                myPopups['wm_men2'].send(userid)
            else:
                # Send message.
                tell(userid, Language('error active', {}, str(gw_language)))

        # 8 : Objective Points
        elif choice == 'op':
            # Variables.
            mod = '[  ]'        if int(es.ServerVar('gw_opoints')) else '[x]'
            val = 0             if int(es.ServerVar('gw_opoints')) else 1
            act = 'deactivated' if int(es.ServerVar('gw_opoints')) else 'activated'

            # Change cvar.
            es.server.queuecmd('gw_opoints %s' % val)

            # Send message.
            tokens = {}
            tokens['admin'] = admin
            tokens['act'] = Language(act, {}, str(gw_language))
            tokens['opt'] = Language('popup line2.8', {}, str(gw_language))
            msgAdmin(Language('activate option', tokens, str(gw_language)))

            # Edit and Send the popup.
            myPopups['wm_men2'].setoption('op', '%s - %s' % (mod, Language('popup line2.8', {}, str(gw_language))))
            myPopups['wm_men2'].send(userid)

        # 9 : Remove Dead Bodies
        elif choice == 'rb':
            # Variables.
            mod = '[  ]'        if int(es.ServerVar('gw_ragdolls')) else '[x]'
            val = 0             if int(es.ServerVar('gw_ragdolls')) else 1
            act = 'deactivated' if int(es.ServerVar('gw_ragdolls')) else 'activated'

            # Change cvar.
            es.server.queuecmd('gw_ragdolls %s' % val)

            # Send message.
            tokens = {}
            tokens['admin'] = admin
            tokens['act'] = Language(act, {}, str(gw_language))
            tokens['opt'] = Language('popup line2.9', {}, str(gw_language))
            msgAdmin(Language('activate option', tokens, str(gw_language)))

            # Edit and Send the popup.
            myPopups['wm_men2'].setoption('rb', '%s - %s' % (mod, Language('popup line2.9', {}, str(gw_language))))
            myPopups['wm_men2'].send(userid)


    # ~~~~~~~~~~~~~~~~~
    # Popup 6 :: Player Management
    elif popupname == 'wm_men6':
        # Swap Teams
        if choice == 'wm_men6.5':
            # Swap teams.
            SwapTeams()

            # Save the log.
            LogSave(userid, 'Swapped Teams')

            # Send the menu.
            WarMenus(userid, 'wm_men6')
        else:
            # Send the menu.
            myPopups[choice].send(userid)


    # ~~~~~~~~~~~~~~~~~
    # Popup 6.1 :: Player Management > Kick
    elif popupname == 'wm_men6.1':
        # Kick Individual player.
        if choice == 'ind':
            # Send the menu.
            myPopups['wm_men6.1.1'].send(userid)
        else:
            # Kick the players.
            KickTeam(choice, userid)

            # Send the menu.
            WarMenus(userid, 'wm_men6.1')


    # ~~~~~~~~~~~~~~~~~
    # Popup 6.2 :: Player Management > Ban
    elif popupname == 'wm_men6.2':
        # Ban Individual player.
        if choice == 'ind':
            # Send the menu.
            myPopups['wm_men6.2.1'].send(userid)
        else:
            # Ban the players.
            BanTeam(choice, userid)

            # Send the menu.
            WarMenus(userid, 'wm_men6.2')


    # ~~~~~~~~~~~~~~~~~
    # Popup 6.6 :: Player Management > Swap to Spectator
    elif popupname == 'wm_men6.6':
        # Swap Individual player.
        if choice == 'ind':
            # Send the menu.
            myPopups['wm_men7.6.1'].send(userid)
        else:
            # Swap players to spectator.
            SwapSpec(choice, userid)

            # Send the menu.
            WarMenus(userid, 'wm_men6.2')


    # ~~~~~~~~~~~~~~~~~
    # Popup 7 :: SourceTv Management
    elif popupname == 'wm_men7':
        # Turn On\Off SourceTv
        if choice == '1':
            # Turn On\Off SourceTv.
            SourceTv_Manager()

            # Send Menu
            WarMenus(userid, 'wm_men7')

        # Start\Stop Demo Record
        elif choice == '2':
            if Store['demo'] == '':
                # Start recording...
                SourceTv_StartRec()
            else:
                # Stop recording...
                SourceTv_StopRec()

            # Send menu.
            WarMenus(userid, 'wm_men7')

        # Auto Recording on LO3
        elif choice == 'autoreclo3':
                # Variables.
                mod = '[  ]' if int(es.ServerVar('gw_sourcetv_autorec_lo3')) == 1 else '[x]'
                val = 0      if int(es.ServerVar('gw_sourcetv_autorec_lo3')) else 1

                # Change cvar.
                es.server.queuecmd('gw_sourcetv_autorec_lo3 %s' % val)

                # Edit and Send the popup.
                myPopups['wm_men7'].setoption('autoreclo3', '%s - %s' % (mod, Language('popup line7.3', {}, str(gw_language))))
                myPopups['wm_men7'].send(userid)

        # Auto Recording on KO3
        elif choice == 'autorecko3':
                # Variables.
                mod = '[  ]' if int(es.ServerVar('gw_sourcetv_autorec_ko3')) == 1 else '[x]'
                val = 0      if int(es.ServerVar('gw_sourcetv_autorec_ko3')) else 1

                # Change cvar.
                es.server.queuecmd('gw_sourcetv_autorec_ko3 %s' % val)

                # Edit and Send the popup.
                myPopups['wm_men7'].setoption('autorecko3', '%s - %s' % (mod, Language('popup line7.4', {}, str(gw_language))))
                myPopups['wm_men7'].send(userid)


    # ~~~~~~~~~~~~~~~~~
    # Other popups
    else:
        myPopups[choice].send(userid)
''' ; end ; '''